/********************** Fuer GCC *******************************
*  Solange GCC kein std::string in Modulen verarbeiten kann sind
*  anstelle der Anweisung
*       import FrameWin
*  folgende Datei(en) einzufuegen:
*       abgel_01a.cxx und abgel_01b.cxx
*
*****************************************************************/
#include <iostream>
#include <format>

// Es muss nur das Modul FrameWin importiert werden,
// da es das Modul Window ebenfalls exportiert
import FrameWin;

// main() Funktion

int main()
{
    // Ein normales Fenster und ein Rahmenfenster erstellen
    Window myWin(10,10,800,600,"Normales Fenster");
    // Beachten Sie die Angabe des enum-Parameter (letzter Parameter)!
    FrameWin myFrameWin(40,40,"Rahmenfenster",FrameWin::FColor::BLAU);

    // Beide Fenster darstellen
    myWin.Draw();
    myFrameWin.Draw();
    // Rahmenfenster verschieben
    // MoveWindow(...) ist Memberfunktion von Window!
    myFrameWin.MoveWindow(0,0);
    // Rahmenfenster erneut darstellen
    myFrameWin.Draw();
}
