module;
#include <iostream>
#include <string>

export module Artikel;
// Definition der Artikelklasse
export class Artikel
{
    // Da die Eigenschaften const sind, ist der
    // Zugriff darauf von abgeleiteten Klassen unkritisch
protected:
    const std::string     name;       // Name
    const unsigned long   nummer;     // Nummer
    inline static unsigned long anun = 1;   // Zaehler Artikelnummer
public:
    Artikel() = default;
    Artikel(const char* const n) : name(n), nummer(anun++)
    { }
};
