#include <iostream>
#include <format>

// Konstante für Zerlegung definieren
const unsigned short var = 0xAA55;

// main() Funktion
int main()
{
    // High-Byte der Variablen ausgeben
    std::cout << std::format("High-Byte von {:#x}: {:#x}\n", var, (var >> 8));
    // Low-Byte der Variablen ausgeben
    std::cout << std::format("Low-Byte von {:#x}: {:#x}\n", var, (var & 0xFF));

    // 2er Potenzen ausgeben
    std::cout << std::format("2 hoch 0: {}\n", (1 << 0));
    std::cout << std::format("2 hoch 1: {}\n", (1 << 1));
    std::cout << std::format("2 hoch 2: {}\n", (1 << 2));
    std::cout << std::format("2 hoch 3: {}\n", (1 << 3));

    // Zum Schluss eine Division durch 8
    std::cout << std::format("244/8: {}\n", (244 >> 3));
}
