#include <iostream>
#include <format>

// Variablen definieren und initialisieren
short shortVar = 10;
char charFix = 0x55;

// main() Funktion
int main()
{
    // charVar als Binärzahl ausgeben
    std::cout << std::format("{:#x} nach binaer: ", charFix);
    // Ausgabe Binärwert. Dazu wird das Bit n (n=7..0) ins
    // Bit 0 geschoben, alle Bits ausser dem Bit 0 ausmaskiert
    // und dann der Wert ausgegeben.
    std::cout << ((charFix >> 7) & 0x01);
    std::cout << ((charFix >> 6) & 0x01);
    std::cout << ((charFix >> 5) & 0x01);
    std::cout << ((charFix >> 4) & 0x01);
    std::cout << ((charFix >> 3) & 0x01);
    std::cout << ((charFix >> 2) & 0x01);
    std::cout << ((charFix >> 1) & 0x01);
    std::cout << ((charFix) & 0x01) << '\n';

    // Bilden des Komplements einer Zahl
    std::cout << std::format("Das 1er Komplement von 10: {}\n", ~shortVar);
    // Bilden des 2er Komplements
    std::cout << std::format("Und eins dazuaddiert ergibt: {}\n", ~shortVar + 1);
}
