module;
#include <iostream>

export module Stack;

// Stackgrösse
constexpr auto SSIZE = 10;
// Klassendefinition
export class Stack
{
   // Die Eigenschaften sind private und damit
   // gegen den direkten Zugriff geschützt
   short stackPtr = 0;
   short values[SSIZE];
 public:
   // Die Memberfunktionen müssen public sein sonst
   // kann mit der Klasse nicht gearbeitet werden
   Stack();
   ~Stack();
   bool Push(short val);
   bool Pop(short& val);
};

// Definition der Memberfunktionen
// Konstruktor
Stack::Stack()
{
   std::cout << "Stack initialisiert!\n";
}
// Destruktor
Stack::~Stack()
{
   std::cout << "Hole restliche Werte vom Stack:\n";
   while (stackPtr > 0)
   {
      stackPtr--;
      std::cout << values[stackPtr] << ' ';
   }
   std::cout << "\nStack geleert!\n";
}
// Wert auf Stack ablegen
bool Stack::Push(short val)
{
   decltype(Push(val)) retval = false;
   // Falls Stack noch nicht voll ist
   if (stackPtr != SSIZE)
   {
      // Neuen Wert ablegen
      values[stackPtr] = val;
      stackPtr++;
      retval = true;
   }
   return retval;
}
// Wert vom Stack holen
bool Stack::Pop(short& val)
{
   decltype(Pop(val)) retval = false;
   // Falls noch Werte auf dem Stack
   if (stackPtr!=0)
   {
      // Wert vom Stack holen
      stackPtr--;
      val = values[stackPtr];
      retval = true;
   }
   return retval;
}
