#include <iostream>
#include <format>

// Deklaration der Funktion zur Berechnung des Rauminhalts
// Zur Demonstration wird hier einmal der Returntyp der Funktion
// mittels decltype bestimmt
auto CalcCube (unsigned short length, unsigned short width,
                        unsigned short height=1)
                        -> decltype(length*width*height);

// main() Funktion
int main()
{
   // Rauminhalt berechnen
    std::cout << std::format("Rauminhalt: {}\n", CalcCube(10, 11, 12));
   // Fläche berechnen
    std::cout << std::format("Flaeche: {}\n", CalcCube(10, 11));
}

// Funktion: CalcCube
// Eingang : Länge, Breite, Höhe des Körpers
// Ausgang : Rauminhalt der Körpers
auto CalcCube(unsigned short length, unsigned short width,
                       unsigned short height)
                       -> decltype(length*width*height)
{
    std::cout << std::format("Daten (L: {}, B: {}, H: {})\n", length, width, height);
    return length * width * height;
}
