
export module Stack;

// Klassendefinition
export class Stack
{
    short *pmyStacks;    // Zeiger auf Stack-Objekt
    short stackPtr = 0;  // Stackindex
    short size;          // Stackgrösse
 public:
    explicit Stack(int s=10);    // ctor, Standard-Stackgrösse 10
    ~Stack(); // dtor
    bool Push(const short val); // Wert auf Stack ablegen
    bool Pop(short& val);       // Wert vom Stack holen
};
// Definition der Memberfunktionen
// Konstruktor
Stack::Stack(int s)
{
    pmyStacks = new short[s]; // Datenfeld reservieren
    size = s; // Grösse merken
}
// Destruktor
Stack::~Stack()
{
    delete [] pmyStacks; // Datenfeld freigeben
}
// Wert auf Stack ablegen
bool Stack::Push(const short val)
{
    auto retval = false; // Returncode
    if (stackPtr < size) // Falls Stack noch nicht voll
    {
        pmyStacks[stackPtr] = val;  // Wert ablegen
        stackPtr++;                 // Stackindex erhöhen
        retval = true;              // OK zurückgeben
    }
    return retval;
}
// Wert vom Stack holen
bool Stack::Pop(short& val)
{
    auto retval = false;    // Returncode
    if (stackPtr>0)         // Falls noch Werte auf dem Stack
    {
        stackPtr--;                 // Stackindex vermindern
        val = pmyStacks[stackPtr];  // Wert zurückgeben
        retval = true;              // OK zurückgeben
    }
    return retval;
}
