/********************** Fuer GCC *******************************
*  Solange GCC offiziell noch keine C++ Module unterstuetzt ist
*  anstelle der Anweisung
*       import Sort
*       import Address
*  folgende Datei(en) einzufuegen:
*       ftempl_01a.cxx
*       ftempl_02a.cxx
*****************************************************************/

#include <iostream>
#include <string>

import Sort;
import Address;

// main() Funktion
int main()
{
    // Objektfeld für Adressdaten anlegen
    const int SIZE = 4;
    Address *pAddress = new Address[SIZE];

    // Objektfeld mit Daten belegen
    pAddress[0].SetData("Karl Maier","AStadt");
    pAddress[1].SetData("Agathe Mueller","XDorf");
    pAddress[2].SetData("Xaver Lehmann","CHausen");
    pAddress[3].SetData("Berta Schmitt","FStadt");

    // unsortiertes Objektfeld ausgeben
    std::cout << "Unsortierte Adressen:\n";
    for (auto index=0; index<SIZE; index++)
        std::cout << pAddress[index];

    // Nun Objektfeld nach Namen sortieren
    Sort(pAddress,SIZE);

    // Sortiertes Objektfeld ausgeben
    std::cout << "\nSortierte Adressen:\n";
    for (auto index=0; index<SIZE; index++)
        std::cout << pAddress[index];

    // Objektfeld löschen
    delete [] pAddress;
}
