// Dateien iostream und iomanip einbinden
#include <iostream>
#include <format>

// Konstante für elektr. Widerstand Kupfer
constexpr auto KWIDERSTAND = 0.0172;
// Leitunglänge in m, Anfangswert mit 10m initialisieren
auto laenge = 10.0;
// Querschnitt der Leitung, Anfangswert 1qmm initialisieren
auto querschnitt = 1.0;

// main() Funktion
int main()
{
    // Leitungswiderstand bei 10m und 1qmm Querschnitt
    auto widerstand = KWIDERSTAND * laenge / querschnitt;
    std::cout << std::format("Widerstand bei {:.2f} m und {:.2f} qmm: {:.2f} Ohm\n",
                             laenge, querschnitt, widerstand);

    // Jetzt Leitungsquerschnitt verdoppeln
    querschnitt *= 2.0;
    widerstand = KWIDERSTAND * laenge / querschnitt;
    std::cout << std::format("Widerstand bei {:.2f} m und {:.2f} qmm: {:.2f} Ohm\n",
        laenge, querschnitt, widerstand);

    // 10-fache Länge
    laenge *= 10.0;
    widerstand = KWIDERSTAND * laenge / querschnitt;
    std::cout << std::format("Widerstand bei {:.2f} m und {:.2f} qmm: {:.2f} Ohm\n",
        laenge, querschnitt, widerstand);
}