module;
#include <iostream>
#include <format>

export module Rect;
// Klassendefinition
export class Rect
{
    short xPos, yPos; // Position
    short width, height; // Breite und Höhe
  public:
    // 1. Konstruktor
    Rect(short x, short y, short w, short h);
    // 2. Konstruktor (Kopierkonstruktor)
    // Hier kann der Standard-Kopierkonstrutor verwendet
    // werden, da keine dyn. Eigenschaften vorhanden sind
    Rect(const Rect& source) = default;
    // Ausgabe der Rechteck Daten
    void PrintRect() const;
};
// Definition der Memberfunktionen
// 1. Konstruktor
// Erhält als Parameter die Rechteck-Daten als 4 short Werte
Rect::Rect(short x, short y, short w, short h)
{
    xPos = x; yPos = y;
    width = w; height = h;
}
// Ausgabe der Rechteck Daten
void Rect::PrintRect() const
{
    std::cout << std::format("Rechteck auf ({}, {}), Groesse: ({},{})\n",
        xPos, yPos, width, height);
}
