module;
#include <iostream>
#include <format>

export module Rect;

// Klassendefinition
export class Rect
{
    short xPos, yPos; // Position
    short width, height; // Breite und Höhe
  public:
    // 1. Memberfunktion zum setzen der Recheck Daten mit 4 Parametern
    void SetData(short x, short y, short w, short h);
    // 2. Memberfunktion zum Kopieren eines Rechtecks
    void SetData(const Rect& source);
    // Ausgabe der Rechteck Daten
    void PrintRect() const;
};
// Definition der Memberfunktionen
// 1. Memberfunktion SetData() der Klasse Rect
// Erhält als Parameter die Rechteck-Daten als 4 short Werte
void Rect::SetData(short x, short y, short w, short h)
{
    xPos = x; yPos = y;
    width = w; height = h;
}
// 2. Memberfunktion SetData() der Klasse Rect
void Rect::SetData(const Rect& source)
{
    xPos = source.xPos; yPos = source.yPos;
    width = source.width; height = source.height;
}
// Ausgabe der Rechteck Daten
void Rect::PrintRect() const
{
    std::cout << std::format("Position: ({},{}), Groesse: ({},{})\n",
        xPos, yPos, width, height);
}
