#include <iostream>

import Rect;

// main () Funktion
int main()
{
    // Zwei Rect Objekte erstellen
    auto pFirstRect = new Rect(10,20,100,200);
    auto pSecondRect = new Rect(50,50,100,200);

    // Rechteckdaten ausgeben
    std::cout << "1. Rechteck:\n" << pFirstRect;
    std::cout << "2. Rechteck:\n" << pSecondRect;

    // Rechtecke vergleichen
    if (*pFirstRect == *pSecondRect)
        std::cout << "Rechtecke sind gleich\n";
    else
        std::cout << "Rechtecke sind unterschiedlich\n";

    // Erstes Objekt verschieben
    // Klammerung unbedingt beachten!
    (*pFirstRect)++;
    std::cout << "1. Rechteck um eins verschoben:\n" << pFirstRect;

    // Neues Rechteck aus der gemeinsamen Fläche der beiden
    // Rechtecke bilden
    auto mergedRect = *pFirstRect & *pSecondRect;
    // Abprüfen, ob beide Rechtecke eine gemeinsame Fläche hatten
    if (!mergedRect)
        std::cout << "Keine Ueberschneidung der beiden Rechtecke!\n";
    else
    {
        std::cout << "Rechtecke ueberschneiden sich! Gemeinsame Flaeche:\n"
            << mergedRect;
    }

    delete pFirstRect;
    delete pSecondRect;
}
