/********************** Fuer GCC *******************************
*  Solange GCC offiziell noch keine C++ Module unterstuetzt ist
*  anstelle der Anweisung
*       import DynArray
*       import Demo
*  folgende Datei(en) einzufuegen:
*       tdefdat_01a.cxx
*       demo.cxx
*
*****************************************************************/

#include <iostream>
#include <format>

import DynArray;
import Demo;

// main() Funktion
int main()
{
    // DynArray mit Default-Datentyp 'int'
    DynArray<> intArray;
    // 5. Element beschreiben
    intArray[4] = 44;
    std::cout << std::format("Initiale int-Feldgroesse: {}\n", intArray.GetSize());
    intArray.PrintArray();
    // 7. Element beschreiben -> führt zur Erweiterung des DynArrays
    intArray[6] = 66;
    // Komplettes Feld ausgeben (7 Elemente)
    std::cout << std::format("Aktuelle int-Feldgroesse: {}\n"
        "Und das komplette int-Feld:\n", intArray.GetSize());
    intArray.PrintArray();

    // DynArray mit 3 Demo-Objekten anlegen
    DynArray<Demo> objArray(3);
    // 2. Element beschreiben
    objArray[1] = Demo("Objekt 1");
    // Komplettes Feld ausgeben (3 Elemente)
    std::cout << std::format("Initiale Demo-Feldgroesse: {}\n", objArray.GetSize());
    objArray.PrintArray();
    // 6. Element beschreiben -> führt zur Erweiterung des DynArrays
    objArray[5] = Demo("Objekt 5");
    // Komplettes Feld ausgeben (6 Elemente)
    std::cout << std::format("Aktuelle Demo-Feldgroesse: {}\n"
        "Und das komplette int-Feld:\n", objArray.GetSize());
    objArray.PrintArray();
}
