/********************** Fuer GCC *******************************
*  Solange GCC offiziell noch keine C++ Module unterstuetzt ist
*  anstelle der Anweisung
*       import SaveFile
*  folgende Datei(en) einzufuegen:
*       tmemtpl_01a.cxx
*
*****************************************************************/

#include <iostream>
#include <format>

import SaveFile;

using namespace std::string_literals;

// main() Funktion
int main()
{
    // Datei-Objekt definieren
    SaveFile testFile("test.dat"s);
    // 3 Daten in Datei schreiben
    char cVal = 'A';
    long double ldVal = 1.0;
    std::string anyString("Dies ist ein String");
    testFile.Write(cVal);
    testFile.Write(ldVal);
    testFile.Write(anyString);
    // Geschriebene Daten zur Kontrolle ausgeben
    std::cout << std::format("Geschriebene Daten: {}, {}, {}\n",
        cVal, ldVal, anyString);
    // Zur Kontrolle Daten auf einen anderen Wert setzen
    cVal = 0;
    ldVal = 0;
    anyString = "";
    // Dateizeiger zurücksetzen
    testFile.Reset();
    // Nun versuchen alle Daten wieder einzulesen
    // Zum Testen einmal die 1. oder 2. Zeile auskommentieren
    try
    {
        testFile.Read(cVal);
        testFile.Read(ldVal);
        testFile.Read(anyString);
    }
    catch (std::string& errMsg)
    {
        std::cout << std::format("Fehler: {}\n", errMsg);
        exit(1);
    }
    // Eingelesen Daten zur Kontrolle ausgeben
    std::cout << std::format("Eingelesene Daten: {}, {}, {}\n",
        cVal, ldVal, anyString);
}
