/********************** Fuer GCC *******************************
*  Solange GCC offiziell noch keine C++ Module unterstuetzt ist
*  anstelle der Anweisung
*       import Matix
*  folgende Datei(en) einzufuegen:
*      tspezn_01a.cxx
*
*****************************************************************/

#include <iostream>

import Matrix;

// main() Funktion
int main()
{
    // Rechteckige Matrix anlegen
    matrix<short,3,4> rectMat;
    // Und mit Werten belegen
    for (auto r=1; r<=3; r++)
        for (auto c=1; c<=4; c++)
            rectMat.setData(r,c,c*10+r);
    // Matrix ausgeben
    std::cout << "Ausgangsmatrix:\n";
    rectMat.Print();
    // Matrix transponieren und ausgeben
    std::cout << "Transponierte Matrix:\n";
    rectMat.Transpose();
    rectMat.Print();

    // Quadratische Matrix anlegen
    matrix<double,4,4> sqrMat;
    // Und mit Werten belegen
    for (auto r=1; r<=4; r++)
        for (auto c=1; c<=4; c++)
            sqrMat.setData(r,c,double(r*100+c)/10.0);
    // Matrix ausgeben
    std::cout << "\nAusgangsmatrix:\n";
    sqrMat.Print();
    // Matrix transponieren und ausgeben
    std::cout << "Transponierte Matrix:\n";
    sqrMat.Transpose();
    sqrMat.Print();
}
