#include <iostream>

import Fahrzeug;

// Anzahl der Fahrzeuge
constexpr int ANZFZ = 4;

int main()
{
    // Feld fuer 3 Fahrzeuge anlegen
    Fahrzeug *fahrzeuge[ANZFZ];
    // Nun die Fahrzeuge anlegen und im Feld abspeichern
    fahrzeuge[0] = new Elektro("VW", "IQ.3", 58);
    fahrzeuge[1] = new Benzin("Porsche", "911", 90);
    fahrzeuge[2] = new Elektro("Renault", "ZOE", 52);
    fahrzeuge[3] = new Benzin("BMW", "M3", 59);
    // Ausgabe der Fahrzeugdaten
    std::cout << "Fahrzeuge:\n";
    for(const auto& fz: fahrzeuge)
        fz->Print();
    // Fahrzeuge auch wieder aufraeumen
    for (auto index=0; index< ANZFZ; index++)
        delete fahrzeuge[index];
}
