#include <iostream>
#include <format>
#include <map>
#include <string>
#include <utility>

// Adressbuch
// Eine Adresse besteht aus einem Namen, einer Telefonnr.
// und einer EMail-Adresse. Doppelte Namen sind nicht
// zulaessig
 class AddressBook
{
    // Container fuer Adressbuch definieren
public:
    // ctor
    AddressBook() = default;
    // dtor
    ~AddressBook() = default;

    // Neue Adresse aufnehmen
    void Insert(std::string_view name, std::string_view phone, std::string_view email)
    {
    }
    // Gibt einzelne Adresse aus
    void PrintAddress(std::string_view name) const
    {
    }
    // Aendert Adressbuch-Eintrag
    // Falls Eintrag 'name' nicht gefunden, false zurueckliefern
    bool Update(std::string_view name, std::string_view phone, std::string_view email)
    {
    }
    // Adresse entfernen
    void Remove(std::string_view name)
    {
    }
    // Ausgabe des gesamten Buches
    void PrintBook()
    {
};


// main() Funktion
int main()
{
    // Adressbuch dynamisch anlegen
    AddressBook *pAddr = new AddressBook;

    // Einige Eintraege hinzufuegen
    pAddr->Insert("Emil Maier", "0111/4545", "emai@sonst.net");
    pAddr->Insert("Agathe Maier", "0111/4545", "agma@sonst.net");
    pAddr->Insert("Franzi Xelsbrot", "08888/1234", "frax@kostnix.de");
    pAddr->Insert("Gustav Gans", "09999/1111", "guga@lucky.com");

    // Komplettes Adressbuch ausgeben
    std::cout << "Inhalt Adressbuch:\n";
    pAddr->PrintBook();

    // Einen Eintrag abaendern
    std::cout << "\nAendere Telefon-Nummer von Gustav Gans:\n";
    auto res = pAddr->Update("Gustav Gans", "09999/7777", "guga@lucky.com");
    // Und geaenderten Eintrag ausgeben
    if (!res)
        std::cout << "Aenderung fehlgeschlagen!\n";
    else
    {
        std::cout << "Neuer Eintrag ist:\n";
        pAddr->PrintAddress("Gustav Gans");
    }

    // Eintrag entfernen
    std::cout << "\nEntferne Franzi Xelsbrot:\n";
    pAddr->Remove("Franzi Xelsbrot");

    // Nochmals komplettes Adressbuch ausgeben
    std::cout << "\nNeuer Inhalt Adressbuch:\n";
    pAddr->PrintBook();

    // Adressbuch loeschen
    delete pAddr;
}
