/********************** Fuer GCC *******************************
*  Solange GCC offiziell noch keine C++ Module unterstuetzt ist
*  anstelle der Anweisung
*       import Stack
*  folgende Datei(en) einzufuegen:
*       ctor_01a.cxx
*
*****************************************************************/


#include <iostream>
#include <format>
#include <cstdlib>

import Stack;

// main() Funktion
int main()
{
   // Stackobjekt definieren
   Stack myStack;
   // Sonstige lokale Variablen definieren
   bool retVal;
   short val;

   // Stack so lange füllen bis er voll ist
   std::cout << "Schiebe Werte auf Stack:\n";
   do
   {
      val = std::rand() % 100;
      retVal = myStack.Push(val);
      if (retVal)
          std::cout << std::format("{} ", val);
   } while (retVal);

   // 5 Werte vom Stack wieder holen
   std::cout << "\nLese 5 Werte vom Stack:\n";
   for (auto iIndex=0; iIndex<5; iIndex++)
   {
      myStack.Pop(val);
      std::cout << std::format("{} ", val);
   }
   std::cout << '\n';
}
