#include <iostream>
#include <format>
#include <cstdlib>

import Stack;

// Stack-Objekt definieren
Stack myStack(5); // Stack mit 5 Einträgen anlegen

// main() Funktion
int main()
{
    short value;
    bool retVal;

    // Werte auf Stack ablegen
    std::cout << "Werte auf Stack : ";
    do
    {
        value = static_cast<short>(std::rand()%100);
        if (retVal = myStack.Push(value); retVal)
            std::cout << std::format("{},", value);
    } while (retVal); // bis Stack voll

    // Werte vom Stack auslesen
    std::cout << "\nUnd jetzt wieder lesen: ";
    do
    {
        if (retVal = myStack.Pop(value); retVal)
            std::cout << std::format("{},", value);
    } while (retVal); // bis Stack leer
    std::cout << '\n';

}
