module;

#include <iostream>
#include <format>
#include <fstream>
#include <string>

export module Window;
// Klassendefinition
export class Window
{
    int xPos, yPos;         // Position
    int width, height;      // Groesse
    std::string *pTitle;    // Titel
  public:
    // Konstruktor
    Window()
    {
        std::cout << "Speicher fuer Fenster reserviert.\n";
        // Immer eine gute Idee: Zeiger mit dem nullptr initialisieren
        pTitle = nullptr;
    }
    // Destruktor
    ~Window()
    {
        std::cout << "Speicher fuer Fenster freigegeben\n";
        // Speicher für Fenstertitel freigeben!
        delete pTitle;
    }
    void Print () const;
    bool ReadFromFile(std::ifstream&);
};
// Definition der Memberfunktionen
// Fensterdaten ausgeben
void Window::Print() const
{
    std::cout << std::format("Fenster : '{}'\nPosition: {:4},{:4}\nGroesse : {:4},{:4}\n",
        *pTitle, xPos, yPos, width, height);
}
// Liest ein Fensterdaten aus der uebergebenen Datei ein
bool Window::ReadFromFile(std::ifstream& inFile)
{
    bool retVal;
    // Fensterposition
    // Fehlerhaftes Dateiende abfangen!
    inFile >> xPos >> yPos;
    if (retVal = inFile.eof(); !retVal)
	{
		// Fenstergrösse einlesen
		 inFile >> width >> height;
		// string Objekt für Fenstertitel dyn. anlegen
		 pTitle = new std::string;
		// Fenstertitel einlesen
        // fuehrendes Leerzeichen ueberspringen
        inFile.ignore(1);
		std::getline(inFile,*pTitle);
	}
    return !retVal;
}
