#include <iostream>
#include <format>

import Sort;

// main() Funktion
int main()
{
    // Felder mit den zu sortierenden Daten
    long    longArray[] {1,-10,-2,20};
    double  doubleArray[] {1.1, 0.9, -1.2, 5.5};

    // Anzahl der Elemente in den Feldern berechnen!
    constexpr auto noOfLongs = sizeof(longArray)/sizeof(longArray[0]);
    constexpr auto noOfDouble = sizeof(doubleArray)/sizeof(doubleArray[0]);

    // unsortiertes long-Feld ausgeben
    std::cout << "Unsortierte long:\n";
    for (auto elem : longArray)
        std::cout << std::format("{}, ", elem);
    std::cout << '\n';
    // -> erzeugt Funktion: void Sort(long*, int);
    Sort(longArray,noOfLongs);
    // sortiertes long-Feld ausgeben
    std::cout << "Sortierte long:\n";
    for (auto elem: longArray)
        std::cout << std::format("{}, ", elem);
    std::cout << "\n\n";

    // unsortiertes double Feld ausgeben
    std::cout << "Unsortiert double:\n";
    for (auto elem: doubleArray)
        std::cout << std::format("{}, ", elem);
    std::cout << '\n';
    // -> erzeugt Funktion: void Sort(double*, int);
    Sort(doubleArray,noOfDouble);
    // sortiertes double-Feld ausgeben
    std::cout << "Sortierte double:\n";
    for (auto elem: doubleArray)
        std::cout << std::format("{}, ", elem);
    std::cout << '\n';
}
