export module Stack;

// Stackgrösse festlegen
constexpr auto SSIZE = 10;

// Klassendefinition
export class Stack
{
   // Eigenschaften
   short values[SSIZE]; // Feld für Ablage der Werte
   short stackPtr = 0; // Feldindex (Stackindex)
 public:
   // Schnittstelle
   bool Push(short val); // Wert auf Stack ablegen
   bool Pop(short& val); // Wert vom Stack abholen
};

// Definition der Memberfunktionen
// Wert auf Stack ablegen
bool Stack::Push(short val)
{
   bool retval = false; // Returnwert initialisieren
   // Falls Stack noch nicht voll ist
   if (stackPtr != SSIZE)
   {
      // Neuen Wert ablegen
      values[stackPtr] = val;
      stackPtr++;
      // Returnwert auf true setzen
      retval = true;
   }
   return retval;
}
// Wert vom Stack holen
bool Stack::Pop(short& val)
{
   bool retval = false; // Returnwert initialisieren
   // Falls noch Werte auf dem Stack
   if (stackPtr!=0)
   {
      // Wert vom Stack holen
      stackPtr--;
      val = values[stackPtr];
      // Returnwert auf true setzen
      retval = true;
   }
   return retval;
}
