#include <iostream>

import Rect;

// main () Funktion
int main()
{
    // Zwei Rect Objekte erstellen
    auto pFirstRect = new Rect(10,20,100,200);
    auto pSecondRect = new Rect(50,50,100,200);

    // Rechteckdaten ausgeben
    std::cout << "1. Rechteck:\n";
    pFirstRect->PrintRect();
    std::cout << "2. Rechteck:\n";
    pSecondRect->PrintRect();

    // Rechtecke vergleichen
    if (*pFirstRect == *pSecondRect)
        std::cout << "Rechtecke sind gleich\n";
    else
        std::cout << "Rechtecke sind unterschiedlich\n";

    // Neues Rechteck aus der gemeinsamen Fläche der beiden
    // Rechtecke bilden
    auto mergedRect = *pFirstRect & *pSecondRect;
    // Abprüfen, ob beide Rechtecke eine gemeinsame Fläche hatten
    if (!mergedRect)
        std::cout << "Keine Ueberschneidung der beiden Rechtecke!\n";
    else
    {
        std::cout << "Rechtecke ueberschneiden sich! Gemeinsame Flaeche:\n";
        mergedRect.PrintRect();
    }

    delete pFirstRect;
    delete pSecondRect;
}
