module;
#include <iostream>

export module Graphics;

// Basisklasse für Grafikobjekte
// Diese Klasse muss mind. eine virtuelle Memberfunktion enthalten!
export class GBase
{
public:
    virtual void Draw() const = 0;
};

// Klasse für Kreise
export class Circle: public GBase
{
public:
    virtual void Draw() const
    {
        std::cout << "Kreis zeichnen\n";
    }
};

// Klasse für Rechtecke
export class Rect: public GBase
{
public:
    virtual void Draw() const
    {
        std::cout << "Rechteck zeichnen\n";
    }
};

// Klasse für Polygone
export class Polygon: public GBase
{
public:
    virtual void Draw() const
    {
        std::cout << "Polygon zeichnen\n";
    }
};
