#include <iostream>
#include <format>

// const char Zeiger definieren
const char* pszText;
// 2 short Variablen definieren/initialiseren
short nVar1 = 10, nVar2 = 20;
// short Zeiger definieren
decltype(nVar1)* pnPtr;

// main() Funktion
int main()
{
    // Inhalt der short Variablen ausgeben
    std::cout << std::format("nVar1: {}, nVar2: {}\n", nVar1, nVar2);
    // Nun Zeiger auf die zweite short Variable setzen
    pnPtr = &nVar2;
    // Und Inhalt der Speicherstelle ausgeben
    std::cout << std::format("*pnPtr: {}\n", *pnPtr);
    // Über den Zeiger der Variablen nVar2 den Wert von nVar1 zuweisen
    *pnPtr = nVar1;
    // nVar2 zur Kontrolle ausgeben
    std::cout << std::format("nVar2 nach Zuweisung ueber Zeiger: {}\n", nVar2);
    // Und jetzt noch die Adressen der beiden short Variablen ausgeben
    std::cout << std::format("nVar1 hat die Adresse: {:p}\n"
        "nVar2 hat die Adresse: {:p}\n",
        reinterpret_cast<void*>(&nVar1), reinterpret_cast<void*>(&nVar2));

    // Zeiger auf einen String setzen und String dann ausgeben
    pszText = "String";
    std::cout << std::format("pszText zeigt auf einen {}\n", pszText);
}
