// Header-Dateien einbinden
...

// Basisklassen-Template fr 'normalen' Drehschalter
template <typename T=unsigned short>
class SpinButton
{
  protected:
    T value;    // akt. Wert
    T minValue; // min. Wert
    T maxValue; // max. Wert
  public:
    SpinButton()
    {
        minValue = std::numeric_limits<T>::min();
        maxValue = std::numeric_limits<T>::max();
        value = minValue;
    }
    void ShowProperties()
    {
        std::cout << std::format("Datentyp: {}\n",
                     typeid(T).name());
        std::cout << std::format("Min/Max: ({}/{}), "
                      "akt.Wert: {}\n",
                     minValue, maxValue, value);
    }
    void StepUp()
    {
        if (value < maxValue)
           value++;
    }
    void StepDown()
    {
        if (value > minValue)
            value--;
    }
};

int main()
{
    ...
}
