// Header-Dateien einbinden
...

// Template-Definitionen
...

// main() Funktion
int main()
{
    // Platz fuer int-Wert mit malloc anlegen
    std::cout << "int mit MallocAlloc:\n";
    StoreData<int, MallocAlloc> intParam;
    intParam.SetData(10);
    intParam.PrintData();
    // Platz fuer string-Wert mit new anlegen
	    std::cout << "\nstring mit NewAlloc:\n";
    StoreData<std::string, NewAlloc> stringParam;
    stringParam.SetData("Another string");
    stringParam.PrintData();
    // Platz fuer float-Wert mit Default-Allok. anlegen
    std::cout << "\nfloat mit Default-Template:\n";
    StoreData<float> floatParam;
    floatParam.SetData(3.1416f);
    floatParam.PrintData();
    // Platz fuer Demo-Objekt mit malloc anlegen
    std::cout << "\nDemo mit MallocAlloc:\n";
    StoreData<Demo, MallocAlloc> classParam;
    classParam.PrintData();
    classParam.SetData(Demo("A new string"));
    classParam.PrintData();
    // Ab hier wird wieder aufgerumt
    std::cout << "\nUnd alles wieder entfernen:\n";
}
